/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_LOTE                                                     */
/* Tabela : LOTE                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_LOTE'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_LOTE
GO

CREATE TRIGGER DTULTATU_LOTE
ON LOTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'LOTE', CDFILIAL, 'CDFILIAL='  + CDFILIAL  + ';'+
                                         'NRLOTEESTQ='+ NRLOTEESTQ+ ';'+
                                         'NRSUBLOTE=' + NRSUBLOTE + ';'+
                                         'CDPRODUTO=' + CDPRODUTO + ';' +';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE LOTE
      SET DTULTATULOTE = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(LOTE.CDFILIAL,0)   = ISNULL(INSERTED.CDFILIAL,0))   AND
            (ISNULL(LOTE.NRLOTEESTQ,0) = ISNULL(INSERTED.NRLOTEESTQ,0)) AND
            (ISNULL(LOTE.NRSUBLOTE,0)  = ISNULL(INSERTED.NRSUBLOTE,0))  AND
            (ISNULL(LOTE.CDPRODUTO,0)  = ISNULL(INSERTED.CDPRODUTO,0));
   END;
END;
GO

