/* Teknisa - Tecnologia em Informtica

Nome: 3906_CDPFUNO.SQL

Descrio:
Funo para retornar a quantidade de Mat.Prima/Insumos calculada.

Criao:
04/06/2004 - Fabrcio Marcelo da Silva

@..\Sql\End_Conv\Oracle\3906_CDPFUNO.SQL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'QTPREVI_MATPRIMA' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION QTPREVI_MATPRIMA
GO

CREATE FUNCTION QTPREVI_MATPRIMA(
   @P_CDFILIAL      VARCHAR(4),
   @P_CDPRODUTO     VARCHAR(10),
   @P_CDPROCFABRIC  VARCHAR(10),
   @P_CDETAPAPROD   VARCHAR(10),
   @P_CDPRODINSUMO  VARCHAR(10),
   @P_QUANTIDADE    FLOAT,
   @P_IDPROPORCAO   VARCHAR(1) = 'S')  RETURNS DOUBLE PRECISION
AS
BEGIN
   DECLARE @V_TIPPROPORCAO  VARCHAR(01);
   DECLARE @V_TIPOARREDOND  VARCHAR(01);
   DECLARE @V_QTINSUMETAPA  FLOAT;
   DECLARE @V_QTRENDINSU    FLOAT;
   DECLARE @V_QTDEPREVI     FLOAT;
   DECLARE @V_QTDEPREVIAUX  FLOAT;
   DECLARE @V_QTPADPROCFAB  FLOAT;
   DECLARE @V_CDESPEPROD    VARCHAR(10);

   SET @V_TIPPROPORCAO = NULL;
   SET @V_TIPOARREDOND = NULL;
   SET @V_QTINSUMETAPA = 0;
   SET @V_QTRENDINSU   = 0;
   SET @V_QTPADPROCFAB = 0;
   SET @V_QTDEPREVIAUX = 0;
   SET @V_QTDEPREVI    = 0;

   SELECT @V_TIPPROPORCAO = MAX(INS.IDTIPOPROPOR),
          @V_TIPOARREDOND = MAX(INS.IDTIPOARREDO),
          @V_QTINSUMETAPA = MAX(INS.QTINSUMETAPA),
          @V_QTRENDINSU   = MAX(INS.QTRENDINSU),
          @V_QTPADPROCFAB = MAX(PR.QTPADPROCFAB)
   FROM
      INSUMETAPA INS,
      PROCFABRICA PR
   WHERE
      (INS.CDFILIAL     = @P_CDFILIAL)     AND
      (INS.CDPRODUTO    = @P_CDPRODUTO)    AND
      (INS.CDPROCFABRIC = @P_CDPROCFABRIC) AND
      (INS.CDETAPAPROD  = @P_CDETAPAPROD)  AND
      (INS.CDPRODINSUMO = @P_CDPRODINSUMO) AND
      (INS.CDFILIAL     = PR.CDFILIAL)     AND
      (INS.CDPRODUTO    = PR.CDPRODUTO)    AND
      (INS.CDPROCFABRIC = PR.CDPROCFABRIC);

   SELECT @V_CDESPEPROD = MAX(CDESPEPROD)
     FROM ESPEPROD
    WHERE (CDFILIAL = @P_CDFILIAL)
      AND (CDPRODUTO  = @P_CDPRODUTO)
      AND (DTVALESPEPRO = (SELECT MAX(DTVALESPEPRO)
                             FROM ESPEPROD
                            WHERE (CDFILIAL = @P_CDFILIAL)
                              AND (CDPRODUTO  = @P_CDPRODUTO)
                              AND (DTVALESPEPRO < GETDATE())));

   IF (@V_CDESPEPROD IS NULL) BEGIN
      SELECT @V_CDESPEPROD = MAX(E1.CDESPEPROD)
        FROM ESPEPROD E1
       WHERE (E1.CDPRODUTO  = @P_CDPRODUTO)
         AND (E1.DTVALESPEPRO = (SELECT MAX(E2.DTVALESPEPRO)
                                   FROM ESPEPROD E2
                                  WHERE (E1.CDFILIAL = E2.CDFILIAL)
                                    AND (E1.CDPRODUTO  = E2.CDPRODUTO)
                                    AND (E2.DTVALESPEPRO < GETDATE())));
   END;

   IF (@V_CDESPEPROD IS NOT NULL) BEGIN
      SELECT @V_QTRENDINSU = MAX(QTPRODTCOMP)
        FROM TCOMPPRO TC
       WHERE (TC.CDPRODUTO  = @P_CDPRODUTO)
         AND (TC.CDESPEPROD = @V_CDESPEPROD)
         AND (ISNULLL(TC.IDTCOMPPROC,'N') = 'S');
      IF @@ROWCOUNT = 0 BEGIN
         SET @V_QTRENDINSU = 0;
      END;
      IF  (@V_QTRENDINSU = 0) BEGIN
          SELECT @V_QTRENDINSU = MAX(QTPRODTCOMP)
            FROM TCOMPPRO TC
           WHERE (TC.CDPRODUTO  = @P_CDPRODUTO)
             AND (TC.CDESPEPROD = @V_CDESPEPROD);
      END;
   END;

   IF (@V_QTRENDINSU = '0') BEGIN
      SET @V_QTRENDINSU = '1';
   END;
   IF (@V_QTPADPROCFAB = '0') BEGIN
      SET @V_QTPADPROCFAB = '1';
   END;

   IF (@P_IDPROPORCAO = 'S') BEGIN
      IF (@V_TIPPROPORCAO = 'N') BEGIN
         SET @V_QTDEPREVI = ((@P_QUANTIDADE * @V_QTINSUMETAPA) / @V_QTRENDINSU);
      END
      ELSE BEGIN
         IF (@V_TIPPROPORCAO = 'L') BEGIN
            IF (@V_TIPOARREDOND = '1') BEGIN
               IF (CONVERT(INTEGER,ROUND(@P_QUANTIDADE,0,0))% CONVERT(INTEGER,ROUND(@V_QTPADPROCFAB,0,0))
               <> 0) BEGIN
                  SET @V_QTDEPREVI = ((ROUND((@P_QUANTIDADE / @V_QTPADPROCFAB),0,1) + 1) * @V_QTINSUMETAPA);
               END
               ELSE BEGIN
                  SET @V_QTDEPREVI = ((@P_QUANTIDADE / @V_QTPADPROCFAB) * @V_QTINSUMETAPA);
               END;
            END
            ELSE BEGIN
               IF (@V_TIPOARREDOND = '2') BEGIN
                  SET @V_QTDEPREVI = ((ROUND((@P_QUANTIDADE / @V_QTPADPROCFAB),0,1)) * @V_QTINSUMETAPA);
               END;
            END;
         END
         ELSE BEGIN
            IF (@V_TIPPROPORCAO = 'U') BEGIN
               SET @V_QTDEPREVI = @V_QTINSUMETAPA;
            END
            ELSE BEGIN
               IF (@V_TIPPROPORCAO = 'I') BEGIN
                  IF (@V_TIPOARREDOND = '0') BEGIN
                     SET @V_QTDEPREVI = (ROUND(((@P_QUANTIDADE / @V_QTPADPROCFAB) * @V_QTINSUMETAPA),0.1));
                  END
                  ELSE BEGIN
                     IF (@V_TIPOARREDOND = '1') BEGIN
                        SET @V_QTDEPREVIAUX = ((@P_QUANTIDADE / @V_QTPADPROCFAB) * @V_QTINSUMETAPA);
                        IF ((CASE WHEN RIGHT(@V_QTDEPREVIAUX,CHARINDEX('.',@V_QTDEPREVIAUX)) ='' THEN '0' 
    		   	     ELSE RIGHT (@V_QTDEPREVIAUX,LEN(@V_QTDEPREVIAUX)-CHARINDEX('.',@V_QTDEPREVIAUX)) END) 
		            <> 0) BEGIN
                           SET @V_QTDEPREVI = (ROUND(((@P_QUANTIDADE / @V_QTPADPROCFAB) * @V_QTINSUMETAPA),0,1) + 1);
                        END
                        ELSE BEGIN
                           SET @V_QTDEPREVI = ((@P_QUANTIDADE / @V_QTPADPROCFAB) * @V_QTINSUMETAPA);
                        END;
                     END
                     ELSE BEGIN
                        IF (@V_TIPOARREDOND = '2') BEGIN
                           SET @V_QTDEPREVI = (ROUND(((@P_QUANTIDADE / @V_QTPADPROCFAB) * @V_QTINSUMETAPA),0,1));
                        END;
                     END;
                  END;
               END;
            END;
         END;
      END;
   END
   ELSE BEGIN
      SET @V_QTDEPREVI = ((@P_QUANTIDADE * @V_QTINSUMETAPA) / @V_QTRENDINSU);
   END;

   RETURN(@V_QTDEPREVI);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'QTPREVI_MATPRIMA','6.10.xxx';
GO